const C3 = self.C3;
self.C3_GetObjectRefTable = function () {
	return [
		C3.Plugins.Particles,
		C3.Plugins.Sprite,
		C3.Behaviors.Sin,
		C3.Behaviors.Orbit,
		C3.Behaviors.Timer,
		C3.Behaviors.Physics,
		C3.Behaviors.solid,
		C3.Behaviors.Tween,
		C3.Plugins.Mouse,
		C3.Plugins.Text,
		C3.Behaviors.scrollto,
		C3.Plugins.Keyboard,
		C3.Plugins.Audio,
		C3.Plugins.Touch,
		C3.Plugins.Arr,
		C3.Plugins.LocalStorage,
		C3.Plugins.Browser,
		C3.Plugins.System.Cnds.IsGroupActive,
		C3.Plugins.System.Cnds.OnLayoutStart,
		C3.Plugins.LocalStorage.Acts.CheckItemExists,
		C3.Plugins.LocalStorage.Cnds.OnItemExists,
		C3.Plugins.LocalStorage.Acts.GetItem,
		C3.Plugins.LocalStorage.Cnds.OnItemGet,
		C3.Plugins.LocalStorage.Acts.ClearStorage,
		C3.Plugins.LocalStorage.Cnds.OnItemMissing,
		C3.Plugins.Arr.Acts.SetXY,
		C3.Plugins.Touch.Cnds.IsTouchingObject,
		C3.Plugins.Sprite.Cnds.CompareFrame,
		C3.Plugins.Sprite.Cnds.IsVisible,
		C3.Plugins.System.Acts.SetVar,
		C3.Plugins.System.Acts.SetLayerVisible,
		C3.Behaviors.Tween.Acts.TweenOneProperty,
		C3.Plugins.Sprite.Acts.SetAnimFrame,
		C3.Behaviors.Tween.Cnds.OnTweensFinished,
		C3.Plugins.Audio.Acts.Play,
		C3.Plugins.Sprite.Acts.Spawn,
		C3.Plugins.Particles.Acts.SetAngle,
		C3.Behaviors.scrollto.Acts.Shake,
		C3.Plugins.Text.Cnds.HasTags,
		C3.Plugins.Text.Acts.TypewriterText,
		C3.Plugins.Arr.Exps.At,
		C3.Plugins.Audio.Acts.PlayByName,
		C3.Plugins.System.Exps.choose,
		C3.Plugins.Sprite.Acts.SetAnim,
		C3.Plugins.Sprite.Acts.SetVisible,
		C3.Plugins.System.Acts.Wait,
		C3.Behaviors.Timer.Acts.StartTimer,
		C3.Plugins.System.Exps.random,
		C3.Plugins.System.Cnds.Compare,
		C3.Plugins.System.Acts.SetLayerInteractive,
		C3.Plugins.Text.Acts.SetText,
		C3.Plugins.Sprite.Cnds.HasTags,
		C3.Plugins.Sprite.Acts.SetPosToObject,
		C3.Behaviors.Orbit.Acts.SetEnabled,
		C3.Behaviors.Sin.Acts.SetEnabled,
		C3.Behaviors.Physics.Acts.SetEnabled,
		C3.Plugins.Sprite.Acts.SetPos,
		C3.Plugins.Sprite.Exps.Y,
		C3.Plugins.System.Cnds.EveryTick,
		C3.Plugins.Sprite.Acts.SetWidth,
		C3.Plugins.Sprite.Exps.AnimationSpeed,
		C3.Behaviors.Timer.Acts.StopAllTimers,
		C3.Plugins.System.Acts.AddVar,
		C3.Plugins.System.Cnds.CompareBoolVar,
		C3.Plugins.System.Cnds.LayerVisible,
		C3.Behaviors.Orbit.Acts.SetSpeed,
		C3.Behaviors.Sin.Acts.SetPeriod,
		C3.Plugins.Sprite.Acts.SetY,
		C3.Behaviors.Sin.Acts.SetPhase,
		C3.Plugins.Sprite.Acts.SetSize,
		C3.Behaviors.Tween.Acts.StopTweens,
		C3.Plugins.Audio.Cnds.OnEnded,
		C3.Plugins.System.Acts.SetBoolVar,
		C3.Plugins.Sprite.Cnds.CompareFrameTag,
		C3.Plugins.Sprite.Acts.SetAnimSpeed,
		C3.Plugins.System.Acts.WaitForPreviousActions,
		C3.Plugins.Browser.Acts.Vibrate,
		C3.Plugins.Touch.Cnds.OnTouchStart,
		C3.Plugins.Text.Cnds.IsRunningTypewriterText,
		C3.Plugins.Text.Acts.TypewriterFinish,
		C3.Plugins.LocalStorage.Acts.SetItem,
		C3.Plugins.LocalStorage.Exps.ItemValue,
		C3.Plugins.Audio.Acts.StopAll,
		C3.Plugins.Sprite.Cnds.IsAnimPlaying,
		C3.Plugins.System.Acts.RestartLayout,
		C3.Plugins.System.Acts.ResetGlobals,
		C3.Plugins.Sprite.Cnds.CompareAnimSpeed,
		C3.Plugins.Sprite.Exps.OriginalAnimationSpeed,
		C3.Plugins.System.Acts.SubVar,
		C3.Plugins.Sprite.Cnds.IsBoolInstanceVarSet,
		C3.Plugins.Sprite.Exps.UID,
		C3.Behaviors.Orbit.Exps.Speed,
		C3.Plugins.Sprite.Cnds.IsOverlapping,
		C3.Plugins.Sprite.Acts.SetBoolInstanceVar,
		C3.Behaviors.Sin.Cnds.ComparePeriod,
		C3.Behaviors.Sin.Exps.Period,
		C3.Plugins.Sprite.Acts.SetInstanceVar,
		C3.Behaviors.Timer.Cnds.IsTimerRunning,
		C3.Behaviors.Timer.Acts.StopTimer,
		C3.Plugins.Touch.Cnds.IsInTouch,
		C3.Plugins.Sprite.Cnds.CompareY,
		C3.Behaviors.Timer.Cnds.OnTimer,
		C3.Behaviors.Sin.Cnds.IsEnabled,
		C3.Behaviors.Sin.Acts.SetMagnitude,
		C3.Plugins.Sprite.Exps.Width,
		C3.Plugins.Sprite.Exps.Height,
		C3.Plugins.Sprite.Cnds.CompareHeight,
		C3.Plugins.Sprite.Cnds.OnCollision,
		C3.Plugins.Touch.Cnds.OnTouchEnd,
		C3.Plugins.Audio.Cnds.IsTagPlaying,
		C3.Plugins.Sprite.Cnds.PickByUID,
		C3.Behaviors.Tween.Cnds.IsPlaying,
		C3.Behaviors.Tween.Acts.TweenValue,
		C3.Plugins.Sprite.Acts.SetEffectParam,
		C3.Behaviors.Tween.Exps.Value
	];
};
self.C3_JsPropNameTable = [
	{P_Dust: 0},
	{P_Hearts: 0},
	{HJ_HUD_Border: 0},
	{Sine: 0},
	{HJ_HUD_thermo: 0},
	{Check: 0},
	{IsOverlaping: 0},
	{SelfY: 0},
	{Combo: 0},
	{IsPerfect: 0},
	{Orbit: 0},
	{Timer: 0},
	{Physics: 0},
	{Solid: 0},
	{Needle: 0},
	{NPC_Girl: 0},
	{Tween: 0},
	{Curtains: 0},
	{Decoy: 0},
	{Count: 0},
	{NPC_Dog: 0},
	{BTN_: 0},
	{Mouse: 0},
	{ScrollTo: 0},
	{Camera: 0},
	{SkillArea: 0},
	{Keyboard: 0},
	{Walls: 0},
	{Audio: 0},
	{Tutorial: 0},
	{Touch: 0},
	{Stats: 0},
	{ArrayStats: 0},
	{LocalStorage: 0},
	{Browser: 0},
	{F_Checks: 0},
	{Score: 0},
	{MiniGame: 0},
	{ActualAnimSpeed: 0},
	{IsFinish: 0},
	{ActualCombo: 0},
	{BestCombo: 0},
	{TotalManual: 0},
	{MXScore: 0},
	{NumMiniGames: 0},
	{LayerTag: 0},
	{Day: 0},
	{AddScore: 0},
	{AddCombo: 0},
	{SkillAreaTag: 0},
	{ImagePoints: 0},
	{MaxCombo: 0},
	{AsteroidCoolDown: 0},
	{CheckUID: 0}
];

self.InstanceType = {
	P_Dust: class extends self.IParticlesInstance {},
	P_Hearts: class extends self.IParticlesInstance {},
	HJ_HUD_Border: class extends self.ISpriteInstance {},
	HJ_HUD_thermo: class extends self.ISpriteInstance {},
	Check: class extends self.ISpriteInstance {},
	Needle: class extends self.ISpriteInstance {},
	NPC_Girl: class extends self.ISpriteInstance {},
	Curtains: class extends self.ISpriteInstance {},
	Decoy: class extends self.ISpriteInstance {},
	Count: class extends self.ISpriteInstance {},
	NPC_Dog: class extends self.ISpriteInstance {},
	BTN_: class extends self.ISpriteInstance {},
	Mouse: class extends self.IInstance {},
	Combo: class extends self.ITextInstance {},
	Camera: class extends self.ISpriteInstance {},
	SkillArea: class extends self.ISpriteInstance {},
	Keyboard: class extends self.IInstance {},
	Walls: class extends self.ISpriteInstance {},
	Audio: class extends self.IInstance {},
	Tutorial: class extends self.ITextInstance {},
	Touch: class extends self.IInstance {},
	Stats: class extends self.ITextInstance {},
	ArrayStats: class extends self.IArrayInstance {},
	LocalStorage: class extends self.IInstance {},
	Browser: class extends self.IInstance {},
	F_Checks: class extends self.ISpriteInstance {}
}